<?php
function Lanthane_BDD_espace_de_travail_select($connex) {
    $res = array() ;
    $req = $connex->prepare("select id, nom, taille_max from espace_de_travail") ;
    $req->execute() ;
    $c = 0 ;
    while ($row = $req->fetch(PDO::FETCH_ASSOC)) {
        $res[$c] = $row ;
        $c = $c+1 ;
    }
    $req->closeCursor() ;
    return $res ;
}


function Lanthane_BDD_espace_de_travail_select_PK($connex, $espace_de_travail) {
    $res = array() ;
    $req = $connex->prepare("select id, nom, taille_max from espace_de_travail where id = ?") ;
    $req->bindParam(1, $espace_de_travail["id"]) ;
    $req->execute() ;
    $res = $req->fetch(PDO::FETCH_ASSOC) ;
    $req->closeCursor() ;
    return $res ;
}


function Lanthane_BDD_espace_de_travail_insert($connex, $espace_de_travail) {
    $res = array() ;
    $req = $connex->prepare("insert into espace_de_travail (nom, taille_max) values (?, ?)") ;
    $req->bindParam(1, $espace_de_travail["nom"]) ;
    $req->bindParam(2, $espace_de_travail["taille_max"]) ;
    $req->execute() ;
    $req->closeCursor() ;
    return $connex->lastInsertId() ;
}


function Lanthane_BDD_espace_de_travail_update_PK($connex, $espace_de_travail) {
    $res = array() ;
    $req = $connex->prepare("update espace_de_travail set nom = ?, set taille_max = ? where id = ?") ;
    $req->bindParam(1, $espace_de_travail["nom"]) ;
    $req->bindParam(2, $espace_de_travail["taille_max"]) ;
    $req->bindParam(3, $espace_de_travail["id"]) ;
    $req->execute() ;
    $res = $req->fetch(PDO::FETCH_ASSOC) ;
    $req->closeCursor() ;
    return $res ;
}


function Lanthane_BDD_espace_de_travail_delete_PK($connex, $espace_de_travail) {
    $res = array() ;
    $req = $connex->prepare("delete from espace_de_travail where id = ?") ;
    $req->bindParam(1, $espace_de_travail["id"]) ;
    $req->execute() ;
    $res = $req->fetch(PDO::FETCH_ASSOC) ;
    $req->closeCursor() ;
    return $res ;
}

function Lanthane_BDD_espace_de_travail_select_PK_utilisateur($connex, $PK) {
	$res = $connex->prepare("select * from espace_de_travail inner join relation_utilisateur_edt on espace_de_travail.id = relation_utilisateur_edt.id_espace_de_travail where pseudo_utilisateur = ?") ;
	$res->bindParam(1, $PK) ;
	$res->execute() ;
	$tab = array() ;
	$c = 0 ;
	while ($row = $res->fetch(PDO::FETCH_NUM)) {
		$tab[$c] = $row ;
		$c = $c+1 ;
	}
	$res->closeCursor() ;
	unset($res) ;
	return $tab ;
}
?>
