<?php
function Lanthane_BDD_fichier_select($connex) {
    $res = array() ;
    $req = $connex->prepare("select id, nom, emplacement, droits_groupe, droits_autres, pseudo_utilisateur, id_espace_de_travail from fichier") ;
    $req->execute() ;
    $c = 0 ;
    while ($row = $req->fetch(PDO::FETCH_ASSOC)) {
        $res[$c] = $row ;
        $c = $c+1 ;
    }
    $req->closeCursor() ;
    return $res ;
}


function Lanthane_BDD_fichier_select_PK($connex, $fichier) {
    $res = array() ;
    $req = $connex->prepare("select id, nom, emplacement, droits_groupe, droits_autres, pseudo_utilisateur, id_espace_de_travail from fichier where id = ?") ;
    $req->bindParam(1, $fichier["id"]) ;
    $req->execute() ;
    $res = $req->fetch(PDO::FETCH_ASSOC) ;
    $req->closeCursor() ;
    return $res ;
}


function Lanthane_BDD_fichier_select_id_espace_de_travail($connex, $fichier) {
    $res = array() ;
    $req = $connex->prepare("select id, nom, emplacement, droits_groupe, droits_autres, pseudo_utilisateur, id_espace_de_travail from fichier where id_espace_de_travail = ?") ;
    $req->bindParam(1, $fichier["id_espace_de_travail"]) ;
    $c = 0 ;
    while ($row = $req->fetch(PDO::FETCH_ASSOC)) {
        $res[$c] = $row ;
        $c = $c+1 ;
    }
    $req->closeCursor() ;
    return $res ;
}


function Lanthane_BDD_fichier_insert($connex, $fichier) {
    $res = array() ;
    $req = $connex->prepare("insert into fichier (nom, emplacement, droits_groupe, droits_autres, pseudo_utilisateur, id_espace_de_travail) values (?, ?, ?, ?, ?, ?)") ;
    $req->bindParam(1, $fichier["nom"]) ;
    $req->bindParam(2, $fichier["emplacement"]) ;
    $req->bindParam(3, $fichier["droits_groupe"]) ;
    $req->bindParam(4, $fichier["droits_autres"]) ;
    $req->bindParam(5, $fichier["pseudo_utilisateur"]) ;
    $req->bindParam(6, $fichier["id_espace_de_travail"]) ;
    $req->execute() ;
    $req->closeCursor() ;
}


function Lanthane_BDD_fichier_update_PK($connex, $fichier) {
    $res = array() ;
    $req = $connex->prepare("update fichier set nom = ?, set emplacement = ?, set droits_groupe = ?, set droits_autres = ?, set pseudo_utilisateur = ?, set id_espace_de_travail = ? where id = ?") ;
    $req->bindParam(1, $fichier["nom"]) ;
    $req->bindParam(2, $fichier["emplacement"]) ;
    $req->bindParam(3, $fichier["droits_groupe"]) ;
    $req->bindParam(4, $fichier["droits_autres"]) ;
    $req->bindParam(5, $fichier["pseudo_utilisateur"]) ;
    $req->bindParam(6, $fichier["id_espace_de_travail"]) ;
    $req->bindParam(7, $fichier["id"]) ;
    $req->execute() ;
    $res = $req->fetch(PDO::FETCH_ASSOC) ;
    $req->closeCursor() ;
    return $res ;
}


function Lanthane_BDD_fichier_delete_PK($connex, $fichier) {
    $res = array() ;
    $req = $connex->prepare("delete from fichier where id = ?") ;
    $req->bindParam(1, $fichier["id"]) ;
    $req->execute() ;
    $res = $req->fetch(PDO::FETCH_ASSOC) ;
    $req->closeCursor() ;
    return $res ;
}

// Tous les fichiers par l'ID de leur espace de travail et par leur emplacement
function Lanthane_BDD_fichier_select_id_espace_de_travail_emplacement($connex, $id, $rep) {
	$res = $connex->prepare("select * from fichier where id_espace_de_travail = ? and emplacement = ?") ;
    $res->bindParam(1, $id) ;
    $res->bindParam(2, $rep) ;
	$res->execute() ;
	$tab = array() ;
	$c = 0 ;
	while ($row = $res->fetch(PDO::FETCH_NUM)) {
		$tab[$c] = $row ;
		$c = $c+1 ;
	}
    $res->closeCursor() ;
    unset($res) ;
	return $tab ;
}
?>
