<?php
function Lanthane_BDD_utilisateur_select($connex) {
    $res = array() ;
    $req = $connex->prepare("select pseudo, mdp, mail, code_langue from utilisateur") ;
    $req->execute() ;
    $c = 0 ;
    while ($row = $req->fetch(PDO::FETCH_ASSOC)) {
        $res[$c] = $row ;
        $c = $c+1 ;
    }
    $req->closeCursor() ;
    return $res ;
}


function Lanthane_BDD_utilisateur_select_PK($connex, $utilisateur) {
    $res = array() ;
    $req = $connex->prepare("select pseudo, mdp, mail, code_langue from utilisateur where pseudo = ?") ;
    $req->bindParam(1, $utilisateur["pseudo"]) ;
    $req->execute() ;
    $res = $req->fetch(PDO::FETCH_ASSOC) ;
    $req->closeCursor() ;
    return $res ;
}


function Lanthane_BDD_utilisateur_insert($connex, $utilisateur) {
    $res = array() ;
    $req = $connex->prepare("insert into utilisateur (pseudo, mdp, mail, code_langue) values (?, ?, ?, ?)") ;
    $req->bindParam(1, $utilisateur["pseudo"]) ;
    $req->bindParam(2, $utilisateur["mdp"]) ;
    $req->bindParam(3, $utilisateur["mail"]) ;
    $req->bindParam(4, $utilisateur["code_langue"]) ;
    $req->execute() ;
    $req->closeCursor() ;
}


function Lanthane_BDD_utilisateur_update_PK($connex, $utilisateur) {
    $res = array() ;
    $req = $connex->prepare("update utilisateur set mdp = ?, set mail = ?, set code_langue = ? where pseudo = ?") ;
    $req->bindParam(1, $utilisateur["mdp"]) ;
    $req->bindParam(2, $utilisateur["mail"]) ;
    $req->bindParam(3, $utilisateur["code_langue"]) ;
    $req->bindParam(4, $utilisateur["pseudo"]) ;
    $req->execute() ;
    $res = $req->fetch(PDO::FETCH_ASSOC) ;
    $req->closeCursor() ;
    return $res ;
}


function Lanthane_BDD_utilisateur_delete_PK($connex, $utilisateur) {
    $res = array() ;
    $req = $connex->prepare("delete from utilisateur where pseudo = ?") ;
    $req->bindParam(1, $utilisateur["pseudo"]) ;
    $req->execute() ;
    $res = $req->fetch(PDO::FETCH_ASSOC) ;
    $req->closeCursor() ;
    return $res ;
}
?>
