/* Script généré automatiquement par Katyusha MCD v0.4.1 pour sqlite3 */


/* Table : utilisateur */

CREATE TABLE utilisateur (
    pseudo VARCHAR(255) NOT NULL PRIMARY KEY, 
    mdp VARCHAR(255) NOT NULL, 
    mail VARCHAR(255) NOT NULL, 
    code_langue CHAR(255) NOT NULL DEFAULT 'eo'
) ;


/* Table : fichier */

CREATE TABLE fichier (
    id INTEGER AUTOINCREMENT NOT NULL PRIMARY KEY, 
    nom VARCHAR(255) NOT NULL, 
    emplacement VARCHAR(255) NOT NULL, 
    droits_groupe SMALLINT NOT NULL, 
    droits_autres SMALLINT NOT NULL, 
    pseudo_utilisateur VARCHAR(255) NOT NULL, 
    id_espace_de_travail INTEGER NOT NULL
) ;


/* Table : espace_de_travail */

CREATE TABLE espace_de_travail (
    id INTEGER AUTOINCREMENT NOT NULL PRIMARY KEY, 
    nom VARCHAR(255) NOT NULL, 
    taille_max INTEGER NOT NULL
) ;


/* Table : relation_utilisateur_edt */

CREATE TABLE relation_utilisateur_edt (
    pseudo_utilisateur VARCHAR(255) NOT NULL, 
    id_espace_de_travail INTEGER NOT NULL, 
    PRIMARY KEY(pseudo_utilisateur, id_espace_de_travail)
) ;





ALTER TABLE utilisateur ADD CONSTRAINT FK_relation_utilisateur_edt_pseudo_utilisateur FOREIGN KEY (pseudo) REFERENCES relation_utilisateur_edt(pseudo_utilisateur) ;

ALTER TABLE espace_de_travail ADD CONSTRAINT FK_relation_utilisateur_edt_id_espace_de_travail FOREIGN KEY (id) REFERENCES relation_utilisateur_edt(id_espace_de_travail) ;

ALTER TABLE fichier ADD CONSTRAINT FK_utilisateur_pseudo_fichier FOREIGN KEY (pseudo) REFERENCES utilisateur(pseudo_utilisateur) ;

ALTER TABLE fichier ADD CONSTRAINT FK_espace_de_travail_id_fichier FOREIGN KEY (id) REFERENCES espace_de_travail(id_espace_de_travail) ;


