/* Script généré automatiquement par Katyusha MCD v0.3.0 pour mysql */

/* Table : utilisateur */

CREATE TABLE utilisateur (
    id INTEGER AUTO_INCREMENT NOT NULL, 
    pseudo VARCHAR(255) NOT NULL, 
    mdp VARCHAR(255) NOT NULL, 
    mail VARCHAR(255) NOT NULL, 
    code_langue CHAR(255) NOT NULL DEFAULT 'eo', 
    PRIMARY KEY(id)
) ;


/* Table : fichier */

CREATE TABLE fichier (
    id INTEGER AUTO_INCREMENT NOT NULL, 
    nom VARCHAR(255) NOT NULL, 
    emplacement VARCHAR(255) NOT NULL, 
    droits_groupe SMALLINT NOT NULL, 
    droits_autres SMALLINT NOT NULL, 
    n_acces INTEGER NOT NULL DEFAULT 0, 
    id_utilisateur INTEGER NOT NULL, 
    id_espace_de_travail INTEGER NOT NULL, 
    PRIMARY KEY(id)
) ;


/* Table : espace_de_travail */

CREATE TABLE espace_de_travail (
    id INTEGER AUTO_INCREMENT NOT NULL, 
    nom VARCHAR(255) NOT NULL, 
    taille_max INTEGER NOT NULL, 
    PRIMARY KEY(id)
) ;


/* Table : relation_utilisateur_edt */

CREATE TABLE relation_utilisateur_edt (
    id_utilisateur INTEGER NOT NULL, 
    id_espace_de_travail INTEGER NOT NULL, 
    PRIMARY KEY(id_utilisateur, id_espace_de_travail)
) ;



ALTER TABLE fichier ADD CONSTRAINT FK_utilisateur_id_utilisateur_fichier FOREIGN KEY (id_utilisateur) REFERENCES utilisateur(id) ;
ALTER TABLE fichier ADD CONSTRAINT FK_espace_de_travail_id_espace_de_travail_fichier FOREIGN KEY (id_espace_de_travail) REFERENCES espace_de_travail(id) ;
ALTER TABLE relation_utilisateur_edt ADD CONSTRAINT FK_utilisateur_id_utilisateur_relation_utilisateur_edt FOREIGN KEY (id_utilisateur) REFERENCES utilisateur(id) ;
ALTER TABLE relation_utilisateur_edt ADD CONSTRAINT FK_espace_de_travail_id_edt_relation_utilisateur_edt FOREIGN KEY (id_espace_de_travail) REFERENCES espace_de_travail(id) ;

