<?php

define("VERSION", "2.1.2") ;

include("C/C.php") ;
//include("C/BDD.php") ;
include("C/Base_php/espace_de_travail.php") ;
include("C/Base_php/fichier.php") ;
include("C/Base_php/utilisateur.php") ;
include("C/Base_php/relation_utilisateur_edt.php") ;

// Import des configurations
include("configs.php") ;

include("langues/FR.php") ;

// Connexion à la base de donnée
$connex = connexion_bd($c) ;

// Démarre la session
session_name($nom_session) ;
session_start() ;


if (!isset($_SESSION["pseudo"])) {
	$_SESSION["connexion"] = false ;
} else {
	$_SESSION["connexion"] = true ;
}


/**
 * Routes
 * connexion : route de connexion, route par défaut quand l'utilisateur n'est pas connecté
 * explore : explorateur de fichier, route par défaut quand l'utilisateur est connecté
 * profil : Gestion du profil utilisateur
 * espaces : gestion et création des espaces de travail
 * insciption : route d'inscription, si inscriptions actives
 */
if ($_SESSION["connexion"] === true) {
	if ($_SESSION["connexion"] === false) {
		$route = "profil" ;
	} else {
		if (!isset($_GET["route"])) {
			$route = "profil" ;
	    } else {
		    $route = $_GET["route"] ;
	    }
	}
} else {
	$route = "connexion" ;
}

$vars = array() ;
if ($route == "connexion") {
    $vars_tp ["titre"] = $langue["lang_titre_connexion"] ;
    $vars_tp["scripts"] = "" ;
    $template = "templates/connexion.html" ;
} elseif ($route == "profil") {
    $vars_tp["scripts"] = "<script src=\"scripts/explorateur.js\"></script>" ;
    // Si aucun espace de travail n'est spécifié, on les affiche tous
    $vars["profil"] = "" ;
    if (!isset($_GET["section"])) {
        $vars_tp ["titre"] = $langue["lang_titre_espaces_travail"] ;
        $edts = Lanthane_BDD_espace_de_travail_select_PK_utilisateur($connex, $_SESSION["pseudo"]) ;
	// Compte les espaces de travail, si aucun, on affiche un message
	if (sizeof($edts) >= 1) {
		// Création des profils HTML des espaces de travail
		$edts_html = "" ;
		foreach ($edts as $edt) {
			$edts_html = $edts_html . template_html("templates/edt.html", array_merge(array("id_edt" => $edt[0] , "nom_edt" => $edt[1]), $langue)) ;
        	}
        	$vars["profil"] = template_html("templates/edts.html", array_merge(array("edts" => $edts_html), $langue)) ;
	} else {
		$vars["profil"] = "<p>" . $langue["lang_aucun_edt"] . "</p>" ;
	}
    } else {
        // Ajout d'un nouvel espace de travail
        if ($_GET["section"] == "ajout_edt") {
            $vars_tp ["titre"] = $langue["lang_titre_creer_edt"] ;
            $vars["profil"] = template_html("templates/ajout_edt.html", array_merge(array("max_taille_edt" => $CONFIG["taille_max_edt"]), $langue)) ;
        /**
         * Explorateur
         */
        } elseif ($_GET["section"] == "explore") {
            $vars_tp ["titre"] = $langue["lang_titre_explore"] ;
            $edt = $_GET["edt"] ;
            // Contrôle si l'utilisateur est membre de l'espace de travail
            if (Lanthane_C_utilisateur_membre_edt_($connex, $_SESSION["pseudo"], $edt)) {
                $vars["profil"] = Lanthane_C_explore($connex, $_SESSION["pseudo"], $edt, $_GET["chemin"], $langue) ;
            }
	// Modification du profil utilisateur
        } elseif ($_GET["section"] == "modifier") {
            $vars_tp ["titre"] = $langue["lang_titre_modifier_profil"] ;
		$vars["profil"] = template_html("templates/modifier_profil.html", array_merge($vars_tp, $langue)) ;
        }
    }
    $template = "templates/profil.html" ;
/**
 * Route d'administration si pseudo root
 */
} elseif ($route == "admin") {
	if ($_SESSION["pseudo"] == "root") {
		$template = "templates/admin.html" ;
		// Section d'ajout d'utilisateur
		if (!isset($_GET["section"])) {
			$vars["section"] = "" ;
		} elseif ($_GET["section"] == "ajout_utilisateur") {
			$vars["section"] = template_html("templates/ajout_utilisateur.html", $langue) ;
		}
	} else {
		header('Location: index.php') ;
	}
} elseif ($route == "deconnexion") {
    session_destroy() ;
    header('Location: index.php') ;
}

$vars["version"] = VERSION ;
$vars_tp["route"] = template_html($template, array_merge($vars, $langue)) ;
// Affiche le rendu
echo(template_html("templates/index.html", $vars_tp)) ;


// Clôture de la connexion à la base de donnée
$connex = null ;
unset($connex) ;
?>
