<?php
$locale["fr"]["langue"] = "Français" ;
$locale["fr"]["titre_page"] = "Installation de Lanthane Serveur" ;
$locale["fr"]["choix_sgbd"] = "Choix du serveur de base de donnée :" ;
$locale["fr"]["choix_bdd"] = "Nom de la base de donnée :" ;
$locale["fr"]["u_bdd"] = "Nom de l'utilisateur de la base de donnée :" ;
$locale["fr"]["pass_bdd"] = "Mot de passe de l'utilisateur de la base de donnée :" ;
$locale["fr"]["pseudo_admin"] = "Le pseudo de l'administrateur de Lanthane Serveur est ''root''" ;
$locale["fr"]["mail_admin"] = "Saisir l'adresse mail pour l'administration de Lanthane Serveur :" ;
$locale["fr"]["pass_admin"] = "Choisir un mot de passe pour l'administration de Lanthane Serveur :" ;
$locale["fr"]["fin"] = "L'installation de Lanthane Serveur est désormais terminée. Pour plus de sécurité, supprimer le fichier ''setup.php''." ;


$locale["en"]["langue"] = "English" ;
$locale["en"]["titre_page"] = "Installation of Lanthane Server" ;
$locale["en"]["choix_sgbd"] = "Choose the DBMS" ;
$locale["en"]["choix_bdd"] = "Database name :" ;
$locale["en"]["u_bdd"] = "Database username :" ;
$locale["en"]["pass_bdd"] = "Database user's password :" ;
$locale["en"]["pseudo_admin"] = "Lanthane Server's administrator name is ''root''" ;
$locale["en"]["mail_admin"] = "Choose an email for administator of Lanthane Server :" ;
$locale["en"]["pass_admin"] = "Choose a password for administator of Lanthane Server :" ;
$locale["en"]["fin"] = "Installation of Lanthane Server is done. For better security, delete ''setup.php'' file." ;


$locale["eo"]["langue"] = "Esperanto" ;
$locale["eo"]["titre_page"] = "Installation Lanthane Server" ;
$locale["eo"]["choix_sgbd"] = "Choose the DBMS" ;
$locale["eo"]["choix_bdd"] = "Database name :" ;
$locale["eo"]["u_bdd"] = "Database username :" ;
$locale["eo"]["pass_bdd"] = "Database user's password :" ;
$locale["eo"]["pseudo_admin"] = "Le pseudo de l'administrateur est ''root''" ;
$locale["eo"]["mail_admin"] = "Saisir l'adresse mail pour l'administration de Lanthane Serveur :" ;
$locale["eo"]["pass_admin"] = "Choisir un mot de passe pour l'administration de Lanthane Serveur :" ;
$locale["eo"]["fin"] = "L'installation de Lanthane Serveur est désormais terminée. Pour plus de sécurité, supprimer le fichier ''setup.php''." ;


$locale["ar"]["langue"] = "العربية" ;
$locale["ar"]["titre_page"] = "تثبيت سيرفر لانثان" ;
$locale["ar"]["choix_sgbd"] = "أختر نظام إدارة قواعد البيانات(DBMS)" ;
$locale["ar"]["choix_bdd"] = "ما اسم قاعده بيانات :" ;
$locale["ar"]["u_bdd"] = "ما اسم المستخدم :" ;
$locale["ar"]["pass_bdd"] = "ما هو رقم المرور :" ;
$locale["ar"]["pseudo_admin"] = "اسم مدير سيرفر لانثان هو root" ;
$locale["ar"]["mail_admin"] = "اختر إيميل  \"البريد الالكتروني\"  للمدير الخاص بسيرفر Lanthane :" ;
$locale["ar"]["pass_admin"] = "Choisir un mot de passe pour l'administration de Lanthane Serveur :" ;
$locale["ar"]["fin"] = "L'installation de Lanthane Serveur est désormais terminée. Pour plus de sécurité, supprimer le fichier ''setup.php''." ;



$sql_base["mysql"] = "
/* Script généré automatiquement par Katyusha MCD v0.4.1 pour mysql */


/* Table : utilisateur */

CREATE TABLE utilisateur (
    pseudo VARCHAR(255) NOT NULL PRIMARY KEY, 
    mdp VARCHAR(255) NOT NULL, 
    mail VARCHAR(255) NOT NULL, 
    code_langue CHAR(255) NOT NULL DEFAULT 'eo', 
    id_fichier INTEGER NOT NULL
) ;


/* Table : fichier */

CREATE TABLE fichier (
    id INTEGER AUTO_INCREMENT NOT NULL PRIMARY KEY, 
    nom VARCHAR(255) NOT NULL, 
    emplacement VARCHAR(255) NOT NULL, 
    droits_groupe SMALLINT NOT NULL, 
    droits_autres SMALLINT NOT NULL
) ;


/* Table : espace_de_travail */

CREATE TABLE espace_de_travail (
    id INTEGER AUTO_INCREMENT NOT NULL PRIMARY KEY, 
    nom VARCHAR(255) NOT NULL, 
    taille_max INTEGER NOT NULL, 
    id_fichier INTEGER NOT NULL
) ;


/* Table : relation_utilisateur_edt */

CREATE TABLE relation_utilisateur_edt (
    pseudo_utilisateur VARCHAR(255) NOT NULL, 
    id_espace_de_travail INTEGER NOT NULL, 
    PRIMARY KEY(pseudo_utilisateur, id_espace_de_travail)
) ;


ALTER TABLE utilisateur ADD CONSTRAINT FK_fichier_id_utilisateur FOREIGN KEY (id) REFERENCES fichier(id_fichier) ;
ALTER TABLE espace_de_travail ADD CONSTRAINT FK_fichier_id_espace_de_travail FOREIGN KEY (id) REFERENCES fichier(id_fichier) ;
ALTER TABLE utilisateur ADD CONSTRAINT FK_relation_utilisateur_edt_pseudo_utilisateur FOREIGN KEY (pseudo) REFERENCES relation_utilisateur_edt(pseudo_utilisateur) ;
ALTER TABLE espace_de_travail ADD CONSTRAINT FK_relation_utilisateur_edt_id_espace_de_travail FOREIGN KEY (id) REFERENCES relation_utilisateur_edt(id_espace_de_travail) ;
" ;

$sql_base["sqlite"] = "

CREATE TABLE utilisateur (
    pseudo VARCHAR(255) NOT NULL PRIMARY KEY, 
    mdp VARCHAR(255) NOT NULL, 
    mail VARCHAR(255) NOT NULL, 
    code_langue CHAR(255) NOT NULL DEFAULT 'eo'
) ;



CREATE TABLE fichier (
    id INTEGER AUTOINCREMENT NOT NULL PRIMARY KEY, 
    nom VARCHAR(255) NOT NULL, 
    emplacement VARCHAR(255) NOT NULL, 
    droits_groupe SMALLINT NOT NULL, 
    droits_autres SMALLINT NOT NULL, 
    pseudo_utilisateur VARCHAR(255) NOT NULL, 
    id_espace_de_travail INTEGER NOT NULL
) ;



CREATE TABLE espace_de_travail (
    id INTEGER AUTOINCREMENT NOT NULL PRIMARY KEY, 
    nom VARCHAR(255) NOT NULL, 
    taille_max INTEGER NOT NULL
) ;



CREATE TABLE relation_utilisateur_edt (
    pseudo_utilisateur VARCHAR(255) NOT NULL, 
    id_espace_de_travail INTEGER NOT NULL, 
    PRIMARY KEY(pseudo_utilisateur, id_espace_de_travail)
) ;



ALTER TABLE utilisateur ADD CONSTRAINT FK_relation_utilisateur_edt_pseudo_utilisateur FOREIGN KEY (pseudo) REFERENCES relation_utilisateur_edt(pseudo_utilisateur) ;
ALTER TABLE espace_de_travail ADD CONSTRAINT FK_relation_utilisateur_edt_id_espace_de_travail FOREIGN KEY (id) REFERENCES relation_utilisateur_edt(id_espace_de_travail) ;
ALTER TABLE fichier ADD CONSTRAINT FK_utilisateur_pseudo_fichier FOREIGN KEY (pseudo) REFERENCES utilisateur(pseudo_utilisateur) ;
ALTER TABLE fichier ADD CONSTRAINT FK_espace_de_travail_id_fichier FOREIGN KEY (id) REFERENCES espace_de_travail(id_espace_de_travail) ;
" ;

$sql_base["pgsql"] = "

CREATE TABLE utilisateur (
    pseudo VARCHAR(255) NOT NULL PRIMARY KEY, 
    mdp VARCHAR(255) NOT NULL, 
    mail VARCHAR(255) NOT NULL, 
    code_langue CHAR(255) NOT NULL DEFAULT 'eo'
) ;



CREATE TABLE fichier (
    id SERIAL  NOT NULL PRIMARY KEY, 
    nom VARCHAR(255) NOT NULL, 
    emplacement VARCHAR(255) NOT NULL, 
    droits_groupe SMALLINT NOT NULL, 
    droits_autres SMALLINT NOT NULL, 
    pseudo_utilisateur VARCHAR(255) NOT NULL, 
    id_espace_de_travail INTEGER NOT NULL
) ;



CREATE TABLE espace_de_travail (
    id SERIAL  NOT NULL PRIMARY KEY, 
    nom VARCHAR(255) NOT NULL, 
    taille_max INTEGER NOT NULL
) ;


CREATE TABLE relation_utilisateur_edt (
    pseudo_utilisateur VARCHAR(255) NOT NULL, 
    id_espace_de_travail INTEGER NOT NULL, 
    PRIMARY KEY(pseudo_utilisateur, id_espace_de_travail)
) ;


ALTER TABLE utilisateur ADD CONSTRAINT FK_relation_utilisateur_edt_pseudo_utilisateur FOREIGN KEY (pseudo) REFERENCES relation_utilisateur_edt(pseudo_utilisateur) ;
ALTER TABLE espace_de_travail ADD CONSTRAINT FK_relation_utilisateur_edt_id_espace_de_travail FOREIGN KEY (id) REFERENCES relation_utilisateur_edt(id_espace_de_travail) ;
ALTER TABLE fichier ADD CONSTRAINT FK_utilisateur_pseudo_fichier FOREIGN KEY (pseudo) REFERENCES utilisateur(pseudo_utilisateur) ;
ALTER TABLE fichier ADD CONSTRAINT FK_espace_de_travail_id_fichier FOREIGN KEY (id) REFERENCES espace_de_travail(id_espace_de_travail) ;

" ;
?>


<?php
// Démarre la session
session_name("Lanthane_installation") ;
session_start() ;
?>

<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8" />
	<meta name="viewport" content="width=device-width, initial-scale=1.0" />
	<title><?php echo($locale["fr"]["titre_page"]) ?></title>
	<link rel="stylesheet" type="text/css" title="general" href="styles/connexion.css" />
	<link rel="shortcut icon" href="images/logo_lanthane.png">
	<script src="libs/prototype.js"></script>
	<style>
	body {
	background : #c19fc8 ;
	padding : 0% ;
	margin : 0% ;
}

input[type="file"], input[type="text"], input[type="password"] {
    background-color : #fff ;
    border : 1px solid #ccc ;
    box-shadow : 0px 1px 1px rgba(0, 0, 0, 0.075) inset ;
    transition : border 0.2s linear 0s, box-shadow 0.2s linear 0s ;
    display : inline-block ;
    height : 1.5em ;
    padding : 0.5em 0.5em ;
    margin-top : 0.5em ;
    margin-bottom : 0.5em ;
    font-size : 90% ;
    line-height : 0px ;
    color : #555 ;
    vertical-align : middle ;
    border-radius : 4px ;
}
form, article {
    margin : 0.5% ;
    padding : 1em ;
	background-color : #eee ;
	border : 1px solid transparent ;
	border-radius : 1px ;
	-webkit-box-shadow : 0 1px 1px rgba(0, 0, 0, 0.05) ;
	box-shadow : 0 1px 1px rgba(0, 0, 0, 0.05) ;
	display : inline-block ;
	border-color : #999 ;
	width : calc(100% - 2em - 2px - 1%) ;
}
	</style>
</head>
<body>

<?php
if (isset($_GET["erreur"])) {
	echo("<p style=\"color : red ;\">" . $_GET["erreur"] . "</p>") ;
}

// Étape 1 : Choix de la langue
if (!isset($_GET["etape"])) {
?>

<form action="setup.php?etape=validation_1" method="post">
    <p>Please, select language :
    
    <select name="lang">
<?php
foreach ($locale as $k => $lang) {
	echo("<option value=\"" . $k . "\">" . $lang["langue"] . "</option>") ;
}
?>
    </select></p>
    <p><input type="submit" /></p>
</form>

<?php

// Validation du choix de la langue
} elseif ($_GET["etape"] == "validation_1") {
	$ok = false ;
	foreach ($locale as $k => $lang) {
		if ($k == $_POST["lang"]) {
			$ok = true ;
		}
	}
	
	if ($ok == true) {
		$_SESSION["langue"] = $_POST["lang"] ;
		header('Location: setup.php?etape=2') ;
	} else {
		header('Location: setup.php?etape=1&erreur=Invalid language') ;
	}

// Étape 2 : Configuration de la BDD
} elseif ($_GET["etape"] == "2") {
?>
<form action="setup.php?etape=validation_2" method="post">
	<p><?php echo($locale[$_SESSION["langue"]]["choix_sgbd"]) ; ?>
	<select name="sgbd">
		<option value="mysql">MySQL</option>
		<option value="pgsql">Postgres</option>
		<option value="sqlite">SQLite3</option>
	</select></p>
	
	<p><?php echo($locale[$_SESSION["langue"]]["choix_bdd"]) ; ?> <input type="text" name="nom_bdd" /></p>
	<p><?php echo($locale[$_SESSION["langue"]]["u_bdd"]) ; ?> <input type="text" name="u_bdd" /></p>
	<p><?php echo($locale[$_SESSION["langue"]]["pass_bdd"]) ; ?> <input type="password" name="pass_bdd" /></p>
	<p><input type="submit" /></p>
</form>
<?php
} elseif ($_GET["etape"] == "validation_2") {
	
	if (isset($_POST["sgbd"]) && isset($_POST["nom_bdd"]) && isset($_POST["u_bdd"]) && isset($_POST["pass_bdd"])) {
		$_SESSION["sgbd"] = $_POST["sgbd"] ;
		$_SESSION["nom_bdd"] = $_POST["nom_bdd"] ;
		$_SESSION["u_bdd"] = $_POST["u_bdd"] ;
		$_SESSION["pass_bdd"] = $_POST["pass_bdd"] ;
		$ok = true ;
	} else {
		$ok = false ;
	}
	
	$contenu = '
<?php
$c = ["sgbd" => "' . $_SESSION["sgbd"] . '", "host" => "127.0.0.1", "base" => "' . $_SESSION["nom_bdd"] . '", "user" => "' . $_SESSION["u_bdd"] . '", "passwd" => "' . $_SESSION["pass_bdd"] . '"] ;
// Langue
$code_langue = "' . strtoupper($_SESSION["lang"]) . '" ;
// Nom des fichiers de configuration
$fichier_config = ".lanthane" ;
$nom_session = "Lanthane_session" ;
$CONFIG["inscription"] = false ;
$CONFIG["ajout_edt"] = true ;
$CONFIG["hash"] = false ;
$CONFIG["taille_max_edt"] = 1000000000 ;
?>
' ;
	
	// Créé la connexion à la base de donnée
	if ($ok == true) {
		$dsn = $_SESSION["sgbd"] . ":dbname=" . $_SESSION["nom_bdd"] . ";host=localhost" ;
		try {
			$connexion = new PDO($dsn, $_SESSION["u_bdd"], $_SESSION["pass_bdd"]) ;
			// Créé les tables et insert le premier utilisateur
			try {
				$connexion->exec($sql_base[$_SESSION["sgbd"]]) ;
			} catch (PDOException $e) {
				echo($e->getMessage()) ;
			}
		}
		catch (PDOException $e) {
			echo($e->getMessage()) ;
		}
	}
	
	// Créé le fichier de configurations
	if ($ok == true) {
		try {
			$stream = fopen("configs.php" "w+") ;
			$fichier = fwrite($stream, $contenu) ;
			header('Location: setup.php?etape=3') ;
		} catch (catchException $e) {
			echo($e->getMessage()) ;
			header('Location: setup.php?etape=2&erreur=' . $e->getMessage()) ;
		}
	}
} elseif ($_GET["etape"] == "3") {
?>

<form action="setup.php?etape=validation_3" method="post">
	<p><?php echo($locale[$_SESSION["langue"]]["pseudo_admin"]) ; ?></p>
	<p><?php echo($locale[$_SESSION["langue"]]["mail_admin"]) ; ?> <input type="mail" name="mail" /></p>
	<p><?php echo($locale[$_SESSION["langue"]]["pass_admin"]) ; ?> <input type="password" name="pass" /></p>
	<p><input type="submit" /></p>
</form>

<?php
} elseif ($_GET["etape"] == "validation_3") {
	$ok = false ;
	if (isset($_POST["pass"]) && isset($_POST["mail"])) {
		$ok = true ;
	}
	
	if ($ok == true) {
		$dsn = $_SESSION["sgbd"] . ":dbname=" . $_SESSION["nom_bdd"] . ";host=localhost" ;
		try {
			$connexion = new PDO($dsn, $_SESSION["u_bdd"], $_SESSION["pass_bdd"]) ;
			// Créé les tables et insert le premier utilisateur
			try {
				$res = $connexion->prepare("insert into utilisateur (pseudo, mail, pass, code_langue) values ('root', ?, ?, ?)") ;
				$res->bindParam(1, $_POST["mail"]) ;
				$res->bindParam(2, password_hash($_POST["pass"], PASSWORD_BCRYPT)) ;
				$res->bindParam(3, $_SESSION["langue"]) ;
			} catch (PDOException $e) {
				echo($e->getMessage()) ;
			}
		}
		catch (PDOException $e) {
			echo($e->getMessage()) ;
		}
		header('Location: setup.php?etape=4') ;
	} else {
		header('Location: setup.php?etape=3') ;
	}

// Étape 2 : Fin de l'installation
} elseif ($_GET["etape"] == "4") {
?>

<article>
<p><?php echo($locale[$_SESSION["langue"]]["fin"]) ; ?></p>
</article>

<?php
}
?>

</body>
</html>
